import * as React from "react";
import { ComponentConfig, ExtractInputPropType, Props, OpaqueLocalProp, LocalProp, InputProp, CallableLocalProp } from "nars-common";
import { PropTypes as LocalPropTypes } from "./LocalPropTypes";
import { SocketLike } from "./SocketLike";
declare type ExtractLocalPropType<T> = T extends OpaqueLocalProp<infer Component, infer Key, infer IsRequired> ? Component extends keyof LocalPropTypes ? Key extends keyof LocalPropTypes[Component] ? IsRequired extends "optional" ? LocalPropTypes[Component][Key] | undefined : LocalPropTypes[Component][Key] : never : never : T extends CallableLocalProp<infer LocalArg, infer ServerArg> ? (localArg: LocalArg, remoteArg: ServerArg) => void : never;
export declare type ExtractLocalPropKeys<T extends Props> = Pick<T, {
    [K in keyof T]: T[K] extends LocalProp ? string : never;
}[keyof T]>;
export declare type ExtractPropTypes<T extends Props> = {
    [K in keyof T]: K extends string ? T[K] extends InputProp<any> ? ExtractInputPropType<T[K]> : ExtractLocalPropType<T[K]> : never;
};
export interface RemoteComponentProps<T extends ComponentConfig, P extends keyof T> {
    name: P;
    props: ExtractPropTypes<T[P]>;
    LoadingComponent?: React.ComponentType;
    ErrorComponent?: React.ComponentType;
}
export declare type Client<T extends ComponentConfig> = React.ComponentType<RemoteComponentProps<T, keyof T>>;
export declare function createRemoteComponentWithUrl<T extends ComponentConfig>(url: string, config: T): {
    ({ name, props, LoadingComponent, ErrorComponent, }: RemoteComponentProps<T, keyof T>): JSX.Element;
    displayName: string;
};
export declare function createRemoteComponentWithWebSocket<T extends ComponentConfig>(webSocket: SocketLike, config: T): {
    ({ name, props, LoadingComponent, ErrorComponent, }: RemoteComponentProps<T, keyof T>): JSX.Element;
    displayName: string;
};
export declare function createRemoteComponent<T extends ComponentConfig>(config: T): {
    ({ name, props, LoadingComponent, ErrorComponent, webSocket, }: RemoteComponentProps<T, keyof T> & {
        webSocket: SocketLike;
    }): JSX.Element;
    displayName: string;
};
export {};
//# sourceMappingURL=Client.d.ts.map