import * as React from "react";
import { SocketLike } from "./SocketLike";
import { RpcInterface } from "./RpcInterface";
export declare type PropsObject = {
    [k: string]: unknown;
};
export declare type PropEncoder = (rpcInterface: RpcInterface) => PropsObject;
export declare type State = "Loading" | "Error" | {
    type: "Rendered";
    element: (React.ReactChild | null)[];
};
export interface Lazy<T> {
    (): T;
}
export declare const useNars: (webSocket: Lazy<SocketLike>, name: string, inputProps: PropEncoder, localProps: PropsObject) => State;
declare type Props = {
    webSocket: SocketLike | Lazy<SocketLike>;
    name: string;
    inputProps: PropEncoder;
    localProps: PropsObject;
    renderError?: () => React.ReactElement<any>;
    renderLoading?: () => React.ReactElement<any>;
};
export declare const RemoteComponent: (props: Props) => React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)> | React.FunctionComponentElement<{}> | null;
export declare const useWebSocket: (url: string, shouldReconnect?: boolean | undefined) => Lazy<WebSocket>;
export {};
//# sourceMappingURL=RemoteComponent.d.ts.map