"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const schema_pb_1 = require("./schema_pb");
const StructCoders_1 = require("./StructCoders");
const Error_1 = require("./Error");
exports.useRpcInterface = (rootId, ws) => {
    const [map] = React.useState(() => new Map());
    let counter = 0;
    return {
        registerCallback: callback => {
            counter = +1;
            map.set(counter, callback);
            return counter;
        },
        executeIncomingRpcCall: (id, encodedArgs) => {
            const callback = map.get(id);
            if (callback) {
                callback(StructCoders_1.ofValue(encodedArgs));
            }
            else {
                throw Error_1.badIncomingRpcCallId(id);
            }
        },
        rpcCall: (messageId, args) => {
            const msg = new schema_pb_1.ClientToServer();
            const call = new schema_pb_1.RpcCall();
            call.setMessageid(messageId);
            call.setArg(StructCoders_1.toValue(args));
            msg.setRpccall(call);
            msg.setRootid(rootId());
            ws().send(msg.serializeBinary());
        },
    };
};
